#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
namespace XPMenus
{
	using System;
	using System.Drawing;
	using System.Collections;
	using System.ComponentModel;
	using System.Data;
	using System.Diagnostics;
	using Microsoft.Win32;
	using System.Threading;
	using System.Windows.Forms;
	using System.Runtime.InteropServices;

	using Syncfusion.Windows.Forms.Tools;
	using Syncfusion.Windows.Forms.Tools.XPMenus;
	using Syncfusion.Win32;
	using Syncfusion.Runtime.Serialization;
	using Syncfusion.Windows.Forms;

	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenu popupMenu2;
		private System.Windows.Forms.ImageList imageList1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager barManager1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem8;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem9;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem10;
		private Syncfusion.Windows.Forms.Tools.XPMenus.DropDownBarItem dropDownBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem11;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem12;
		private System.Windows.Forms.MdiClient mdiClient1;
		private Syncfusion.Windows.Forms.PopupControlContainer popupControlContainer1;
		private System.Windows.Forms.ListBox listBox1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem13;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem14;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem openBarItem;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem closeBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem WindowsMenu;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem exitBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem cascadeBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem tileHBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem tileVBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ListBarItem mruFilesListItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MdiListBarItem mdiListBarItem1;
		private System.Windows.Forms.ImageList largeImageList;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem themesItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem4;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ToolbarListBarItem toolbarListBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem customColorsItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem5;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem undoItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.StaticBarItem staticBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.StaticBarItem staticBarItem2;
		private System.ComponentModel.IContainer components;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;

		private int counter = 1;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.mruFilesListItem.ChildCaptions.AddRange(new string[]{"MRU 1", "MRU 2", "MRU 3"});
			this.mruFilesListItem.CheckedIndices.Add(1);

			// Choosing to show a merged menu/toolbar structure, all the time.
			// Hence registering the Child Form Types that will be instantiated during the course of
			// the application.
			// (You can choose not to invoke a merge explicitly, in which case, the framework
			// will automatically merge the menus/toolbars from the child Forms when instances
			// of those types get created).
			this.barManager1.RegisterMdiChildTypes(new Type[]
							{
								typeof(TextEditorForm),
								typeof(ImageEditorForm)
							});


		}

		private void ListItemClicked(object sender, EventArgs e)
		{
			ListBarItemClickedEventArgs args = e as ListBarItemClickedEventArgs;
			ListBarItem listItem = sender as ListBarItem;

			listItem.CheckedIndices.Clear();
			listItem.CheckedIndices.Add(args.IndexClicked);
			// Refresh, in case this item is put in a ParentBarItem with CloseOnClick = false
			listItem.UpdateCheckedStates();

			MessageBox.Show("ListItem: " + listItem.ChildCaptions[args.IndexClicked]);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.barItem8 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem9 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.popupControlContainer1 = new Syncfusion.Windows.Forms.PopupControlContainer(this.components);
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.barManager1 = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this.components, this);
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.barManager1, "MainMenu");
			this.parentBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.openBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.closeBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.mruFilesListItem = new Syncfusion.Windows.Forms.Tools.XPMenus.ListBarItem();
			this.exitBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem5 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.undoItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.toolbarListBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ToolbarListBarItem();
			this.WindowsMenu = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.cascadeBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.tileHBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.tileVBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.mdiListBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.MdiListBarItem();
			this.parentBarItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItem13 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem14 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.bar2 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.barManager1, "Standard");
			this.themesItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.customColorsItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.bar3 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.barManager1, "StatusBar");
			this.staticBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.StaticBarItem();
			this.staticBarItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.StaticBarItem();
			this.largeImageList = new System.Windows.Forms.ImageList(this.components);
			this.mdiClient1 = new System.Windows.Forms.MdiClient();
			this.barItem12 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem11 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem10 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.dropDownBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.DropDownBarItem();
			this.popupMenu2 = new Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenu(this.components);
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			((System.ComponentModel.ISupportInitialize)(this.barManager1)).BeginInit();
			// 
			// barItem8
			// 
			this.barItem8.CategoryIndex = 0;
			this.barItem8.ID = "Test4";
			this.barItem8.Text = "Test4";
			// 
			// barItem9
			// 
			this.barItem9.CategoryIndex = 0;
			this.barItem9.ID = "Test5";
			this.barItem9.Text = "Test5";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// popupControlContainer1
			// 
			this.popupControlContainer1.Location = new System.Drawing.Point(384, 80);
			this.popupControlContainer1.Name = "popupControlContainer1";
			this.popupControlContainer1.Size = new System.Drawing.Size(96, 96);
			this.popupControlContainer1.TabIndex = 5;
			this.popupControlContainer1.Visible = false;
			// 
			// listBox1
			// 
			this.listBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listBox1.Location = new System.Drawing.Point(0, 0);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(96, 95);
			this.listBox1.TabIndex = 0;
			// 
			// barManager1
			// 
			this.barManager1.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("barManager1.BarPositionInfo")));
			this.barManager1.Bars.Add(this.bar1);
			this.barManager1.Bars.Add(this.bar2);
			this.barManager1.Bars.Add(this.bar3);
			this.barManager1.Categories.Add("File");
			this.barManager1.Categories.Add("Edit");
			this.barManager1.Categories.Add("View");
			this.barManager1.Categories.Add("Window");
			this.barManager1.Categories.Add("&Help");
			this.barManager1.Categories.Add("StatusBar");
			this.barManager1.CurrentBaseFormType = "System.Windows.Forms.Form";
			this.barManager1.Form = this;
			this.barManager1.ImageList = this.imageList1;
			this.barManager1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																									 this.parentBarItem1,
																									 this.parentBarItem5,
																									 this.openBarItem,
																									 this.parentBarItem4,
																									 this.WindowsMenu,
																									 this.closeBarItem,
																									 this.parentBarItem2,
																									 this.mruFilesListItem,
																									 this.exitBarItem,
																									 this.cascadeBarItem,
																									 this.tileHBarItem,
																									 this.tileVBarItem,
																									 this.barItem13,
																									 this.barItem14,
																									 this.mdiListBarItem1,
																									 this.themesItem,
																									 this.toolbarListBarItem1,
																									 this.customColorsItem,
																									 this.undoItem,
																									 this.staticBarItem1,
																									 this.staticBarItem2,
																									 this.barItem1});
			this.barManager1.LargeImageList = this.largeImageList;
			this.barManager1.ResetCustomization = false;
			this.barManager1.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
			// 
			// bar1
			// 
			this.bar1.BarName = "MainMenu";
			this.bar1.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)(((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.parentBarItem1,
																							  this.parentBarItem5,
																							  this.parentBarItem4,
																							  this.WindowsMenu,
																							  this.parentBarItem2});
			this.bar1.Manager = this.barManager1;
			// 
			// parentBarItem1
			// 
			this.parentBarItem1.CategoryIndex = 0;
			this.parentBarItem1.ID = "&File";
			this.parentBarItem1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItem1,
																										this.openBarItem,
																										this.closeBarItem,
																										this.mruFilesListItem,
																										this.exitBarItem});
			this.parentBarItem1.MergeOrder = 1;
			this.parentBarItem1.SeparatorIndices.AddRange(new int[] {
																		3,
																		4});
			this.parentBarItem1.Text = "&File";
			// 
			// openBarItem
			// 
			this.openBarItem.CategoryIndex = 0;
			this.openBarItem.ID = "&Open";
			this.openBarItem.ImageIndex = 0;
			this.openBarItem.MergeOrder = 1;
			this.openBarItem.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.openBarItem.Text = "&Open";
			this.openBarItem.Click += new System.EventHandler(this.openBarItem_Click);
			// 
			// closeBarItem
			// 
			this.closeBarItem.CategoryIndex = 0;
			this.closeBarItem.ID = "&Close";
			this.closeBarItem.ImageIndex = 4;
			this.closeBarItem.MergeOrder = 2;
			this.closeBarItem.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftO;
			this.closeBarItem.Text = "&Close";
			this.closeBarItem.Click += new System.EventHandler(this.closeBarItem_Click);
			// 
			// mruFilesListItem
			// 
			this.mruFilesListItem.CategoryIndex = 0;
			this.mruFilesListItem.ID = "Most Recently Used Files List";
			this.mruFilesListItem.MergeOrder = 10;
			this.mruFilesListItem.Text = "Most Recently Used Files List";
			this.mruFilesListItem.Click += new System.EventHandler(this.ListItemClicked);
			// 
			// exitBarItem
			// 
			this.exitBarItem.CategoryIndex = 0;
			this.exitBarItem.ID = "E&xit";
			this.exitBarItem.MergeOrder = 20;
			this.exitBarItem.Text = "E&xit";
			this.exitBarItem.Click += new System.EventHandler(this.exitBarItem_Click);
			// 
			// parentBarItem5
			// 
			this.parentBarItem5.CategoryIndex = 1;
			this.parentBarItem5.ID = "&Edit";
			this.parentBarItem5.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.undoItem});
			this.parentBarItem5.MergeOrder = 2;
			this.parentBarItem5.Text = "&Edit";
			// 
			// undoItem
			// 
			this.undoItem.CategoryIndex = 1;
			this.undoItem.Enabled = false;
			this.undoItem.ID = "&Undo";
			this.undoItem.MergeType = System.Windows.Forms.MenuMerge.MergeItems;
			this.undoItem.Text = "&Undo";
			// 
			// parentBarItem4
			// 
			this.parentBarItem4.CategoryIndex = 2;
			this.parentBarItem4.ID = "&View";
			this.parentBarItem4.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.toolbarListBarItem1});
			this.parentBarItem4.MergeOrder = 5;
			this.parentBarItem4.Text = "&View";
			// 
			// toolbarListBarItem1
			// 
			this.toolbarListBarItem1.CategoryIndex = 2;
			this.toolbarListBarItem1.ID = "&Toolbars";
			this.toolbarListBarItem1.Text = "&Toolbars";
			// 
			// WindowsMenu
			// 
			this.WindowsMenu.CategoryIndex = 3;
			this.WindowsMenu.ID = "&Window";
			this.WindowsMenu.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																									 this.cascadeBarItem,
																									 this.tileHBarItem,
																									 this.tileVBarItem,
																									 this.mdiListBarItem1});
			this.WindowsMenu.MergeOrder = 19;
			this.WindowsMenu.SeparatorIndices.AddRange(new int[] {
																	 3});
			this.WindowsMenu.Text = "&Window";
			// 
			// cascadeBarItem
			// 
			this.cascadeBarItem.CategoryIndex = 3;
			this.cascadeBarItem.ID = "&Cascade";
			this.cascadeBarItem.ImageIndex = 1;
			this.cascadeBarItem.Text = "&Cascade";
			this.cascadeBarItem.Click += new System.EventHandler(this.cascadeBarItem_Click);
			// 
			// tileHBarItem
			// 
			this.tileHBarItem.CategoryIndex = 3;
			this.tileHBarItem.ID = "Tile &Horizontal";
			this.tileHBarItem.ImageIndex = 2;
			this.tileHBarItem.Text = "Tile &Horizontal";
			this.tileHBarItem.Click += new System.EventHandler(this.tileHBarItem_Click);
			// 
			// tileVBarItem
			// 
			this.tileVBarItem.CategoryIndex = 3;
			this.tileVBarItem.ID = "Tile &Vertical";
			this.tileVBarItem.ImageIndex = 3;
			this.tileVBarItem.Text = "Tile &Vertical";
			this.tileVBarItem.Click += new System.EventHandler(this.tileVBarItem_Click);
			// 
			// mdiListBarItem1
			// 
			this.mdiListBarItem1.CategoryIndex = 3;
			this.mdiListBarItem1.ID = "Window List";
			// 
			// parentBarItem2
			// 
			this.parentBarItem2.CategoryIndex = 4;
			this.parentBarItem2.ID = "&Help";
			this.parentBarItem2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItem13,
																										this.barItem14});
			this.parentBarItem2.MergeOrder = 20;
			this.parentBarItem2.Text = "&Help";
			// 
			// barItem13
			// 
			this.barItem13.CategoryIndex = 4;
			this.barItem13.ID = "Syncfusion on the Web";
			this.barItem13.Text = "Syncfusion on the Web";
			this.barItem13.Click += new System.EventHandler(this.barItem13_Click);
			// 
			// barItem14
			// 
			this.barItem14.CategoryIndex = 4;
			this.barItem14.ID = "&About";
			this.barItem14.Text = "&About";
			this.barItem14.Visible = false;
			// 
			// bar2
			// 
			this.bar2.BarName = "Standard";
			this.bar2.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
			this.bar2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.openBarItem,
																							  this.closeBarItem,
																							  this.themesItem,
																							  this.customColorsItem});
			this.bar2.Manager = this.barManager1;
			// 
			// themesItem
			// 
			this.themesItem.CategoryIndex = 0;
			this.themesItem.Checked = true;
			this.themesItem.ID = "Themes Enabled";
			this.themesItem.ImageIndex = 5;
			this.themesItem.Text = "Themes Enabled";
			this.themesItem.Click += new System.EventHandler(this.themesItem_Click);
			// 
			// customColorsItem
			// 
			this.customColorsItem.CategoryIndex = 0;
			this.customColorsItem.ID = "Custom Colors";
			this.customColorsItem.ImageIndex = 6;
			this.customColorsItem.Text = "Custom Colors";
			this.customColorsItem.Click += new System.EventHandler(this.customColors_Click);
			// 
			// bar3
			// 
			this.bar3.BarName = "StatusBar";
			this.bar3.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)(((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsStatusBar)));
			this.bar3.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.staticBarItem1,
																							  this.staticBarItem2});
			this.bar3.Manager = this.barManager1;
			// 
			// staticBarItem1
			// 
			this.staticBarItem1.CategoryIndex = 5;
			this.staticBarItem1.FlatBorderColor = System.Drawing.SystemColors.GrayText;
			this.staticBarItem1.ID = "Stutus1";
			this.staticBarItem1.Text = "Status1";
			// 
			// staticBarItem2
			// 
			this.staticBarItem2.CategoryIndex = 5;
			this.staticBarItem2.FlatBorderColor = System.Drawing.SystemColors.GrayText;
			this.staticBarItem2.ID = "Status2";
			this.staticBarItem2.Text = "Status2";
			// 
			// largeImageList
			// 
			this.largeImageList.ImageSize = new System.Drawing.Size(32, 32);
			this.largeImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("largeImageList.ImageStream")));
			this.largeImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// mdiClient1
			// 
			this.mdiClient1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.mdiClient1.Location = new System.Drawing.Point(0, 50);
			this.mdiClient1.Name = "mdiClient1";
			this.mdiClient1.TabIndex = 4;
			// 
			// barItem12
			// 
			this.barItem12.CategoryIndex = 0;
			this.barItem12.ID = "dummy";
			this.barItem12.Text = "dummy";
			// 
			// barItem11
			// 
			this.barItem11.CategoryIndex = 2;
			this.barItem11.ID = "Tseting";
			this.barItem11.Text = "Tseting";
			// 
			// barItem10
			// 
			this.barItem10.CategoryIndex = 0;
			this.barItem10.ID = "Test";
			this.barItem10.Text = "Test";
			// 
			// dropDownBarItem1
			// 
			this.dropDownBarItem1.CategoryIndex = 1;
			this.dropDownBarItem1.ID = "DropDown";
			this.dropDownBarItem1.Text = "DropDown";
			// 
			// popupMenu2
			// 
			this.popupMenu2.ParentBarItem = this.parentBarItem1;
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Filter = "txt files (*.txt)|*.txt|Image Files (*.bmp; *.ico)|*.bmp;*.ico";
			this.openFileDialog1.FilterIndex = 0;
			this.openFileDialog1.Title = "Text or Image File Selection Dialog";
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = 0;
			this.barItem1.ID = "New Derived Form";
			this.barItem1.Text = "New Derived Form";
			this.barItem1.Click += new System.EventHandler(this.barItem1_Click);
			// 
			// MainForm
			// 
			this.AccessibleName = "";
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 341);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.IsMdiContainer = true;
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Main Form (Syncfusion Inc)";
			this.MdiChildActivate += new System.EventHandler(this.MainForm_MdiChildActivate);
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.barManager1)).EndInit();

		}
		#endregion

		#region DLL Imports
		[DllImport("user32.dll", CharSet=CharSet.Auto)]
		extern public static bool SetForegroundWindow(IntPtr hwnd);
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			// Safe mode check
			// Uncomment this to include support for running this app in "Safe Mode" (when persisted data will not be loaded).
			// SafeModeCheck();

			// Modify this version, whenever changes are made such that the persisted state cannot be loaded anymore.
			string curVersion = "1.0";
			ValidatePersistedStateVersion(curVersion);
			StoreVersionInfo(curVersion);

			MainForm mainForm = new MainForm();

			bool bRunning = false;
			foreach ( Process p in Process.GetProcesses(System.Environment.MachineName) )
			{
				if( p.MainWindowHandle != IntPtr.Zero)
				{
					// Process name gets truncated!
					if(p.ProcessName == "XPMenus")
					{
						bRunning = true;
						MessageBox.Show("Activating the already open instance of XPMenus.exe.");
						SetForegroundWindow(p.MainWindowHandle);
						break;
					}
				}
			}
			if(!bRunning)
			{
				Application.Run(mainForm);
				OnAppShutDown();
			}		
		}

		#region VERSIONING
		private static bool safeModeOn = false;
		static void SafeModeCheck()
		{
			object value;
			RegistryKey regKey = Registry.CurrentUser;
			regKey = regKey.CreateSubKey("Software\\Syncfusion\\XPMenus");
			AppStateSerializer ass = new AppStateSerializer(SerializeMode.WindowsRegistry, regKey);
			value = ass.DeserializeObject("SafeModeFlag");

			if(value != null)
				safeModeOn = (bool)value;

			if(safeModeOn)
			{
				MessageBox.Show("Previous instantiation of this application did not shut down properly. Running in safe mode. User specific persisted information will not be loaded. You can turn off safe mode when the application exits.", "Safe Mode Information", MessageBoxButtons.OK, MessageBoxIcon.Information);
				AppStateSerializer.GetSingleton().Enabled = false;
			}
			else
			{
				RegistryKey key = Registry.CurrentUser;
				key = key.CreateSubKey("Software\\Syncfusion\\XPMenus");
				// turn on safe mode (will be reset if app closed safely)
				ass.SerializeObject("SafeModeFlag", (object)true);
			}
		}

		static void OnAppShutDown()
		{
			RegistryKey regKey = Registry.CurrentUser;
			regKey = regKey.CreateSubKey("Software\\Syncfusion\\XPMenus");

			bool resetFlag = false;
			if(safeModeOn)
			{
				DialogResult dlgResult = MessageBox.Show("Would you like to turn off Safe Mode?", "Safe Mode information", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dlgResult == DialogResult.Yes)
					resetFlag = true;
			}
			else
				resetFlag = true;

			AppStateSerializer.GetSingleton().Enabled = true;

			if(resetFlag)
			{
				AppStateSerializer ass = new AppStateSerializer(SerializeMode.WindowsRegistry, regKey);
				ass.SerializeObject("SafeModeFlag", (object)false);
			}
		}

		static string VersionTag = "AppVersion";
		static void ValidatePersistedStateVersion(string curVersion)
		{
			// Versioning
			AppStateSerializer serializer = AppStateSerializer.GetSingleton();
			object objectOut = serializer.DeserializeObject(VersionTag);
			if(objectOut != null)
			{
				string version = (string)objectOut;
				version = version.ToLower();

				curVersion = curVersion.ToLower();

				// Persisted info is not the current version, lets lose it.
				if(version != curVersion)
					serializer.FlushSerializer();
			}
		}
		// Store the current version, so that we can validate it the next time.
		static void StoreVersionInfo(string curVersion)
		{
			AppStateSerializer serializer = AppStateSerializer.GetSingleton();
			serializer.SerializeObject(VersionTag, curVersion, true);
		}
		#endregion VERSIONING

		#region XPMenusInitialization

		private void Form1_Load(object sender, System.EventArgs e)
		{
			bool found = true;
			try
			{
				this.AddDocument(new TextEditorForm("..\\..\\Description.txt"));
				this.AddDocument(new ImageEditorForm("..\\..\\logo.jpg"));
			}
			catch{found = false;}
			if(!found)
			{
				try
				{
					this.AddDocument(new TextEditorForm("csharp.ini"));
					this.AddDocument(new ImageEditorForm("suite.gif"));
				}
				catch{}
			}

			// Application specific initialization
			this.UpdateMenuItems();
		}

		#endregion XPMenusInitialization

		#region SampleAppLogic
		private void AddDocument(Form newForm) 
		{
			newForm.MdiParent = this;
			newForm.Show();
		}

		private void openBarItem_Click(object sender, System.EventArgs e)
		{
			DocumentTypeSelectionDialog dlg = new DocumentTypeSelectionDialog();
			if(dlg.ShowDialog() != DialogResult.OK)
				return;

			int docType = dlg.SelectedType;

			this.openFileDialog1.FileName = String.Empty;
			if(docType == 0)
				this.openFileDialog1.Filter = "txt files (*.txt)|*.txt|All Files (*.*)|*.*";
			else if(docType == 1)
				this.openFileDialog1.Filter = "Image Files (*.bmp; *.ico; *.jpg)|*.bmp;*.ico;*.jpg|All Files (*.*)|*.*";

			if(this.openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				string filename = this.openFileDialog1.FileName;
				filename = filename.ToLower();
				//if(filename.IndexOf(".txt") != -1)
				if(docType == 0)
				{
					// Text file opened
					TextEditorForm childForm = new TextEditorForm(filename);
					this.AddDocument(childForm);
				}
//				else if(filename.IndexOf(".bmp") != -1
//					|| filename.IndexOf(".ico") != -1)
				else if(docType == 1)
				{
					try
					{
						ImageEditorForm imageEditor = new ImageEditorForm(filename);
						this.AddDocument(imageEditor);
					}
					catch{};
				}
			}
		}
		
		private void closeBarItem_Click(object sender, System.EventArgs e)
		{
			Form activeChild = this.ActiveMdiChild;
			if(activeChild != null)
				activeChild.Close();
		}

		private void MainForm_MdiChildActivate(object sender, System.EventArgs e)
		{
			this.UpdateMenuItems();
		}

		private void UpdateMenuItems()
		{
			if(this.ActiveMdiChild != null)
			{
				this.closeBarItem.Enabled = true;
				this.WindowsMenu.Enabled = true;
			}
			else
			{
				this.closeBarItem.Enabled = false;
				this.WindowsMenu.Enabled = false;
			}
		}

		private void exitBarItem_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		
		private void cascadeBarItem_Click(object sender, System.EventArgs e)
		{
			this.LayoutMdi(MdiLayout.Cascade);
		}

		private void tileHBarItem_Click(object sender, System.EventArgs e)
		{
			this.LayoutMdi(MdiLayout.TileHorizontal);
		}

		private void tileVBarItem_Click(object sender, System.EventArgs e)
		{
			this.LayoutMdi(MdiLayout.TileVertical);
		}
		#endregion SampleAppLogic

		
		#region AboutForm_Logic
		DemoCommon.AboutForm aboutForm = null;
		private void barItem13_Click(object sender, System.EventArgs e)
		{
			aboutForm = new DemoCommon.AboutForm();
			aboutForm.label1.Text = "Syncfusion Essential Tools - LayoutManagers Sample";
			aboutForm.button1.Click += new EventHandler(this.AboutFormCloseBtnClicked);
			aboutForm.AcceptButton = aboutForm.button1;
			aboutForm.ShowDialog();
		}
		private void AboutFormCloseBtnClicked(object sender, EventArgs e)
		{
			aboutForm.Close();
		}
		#endregion AboutForm_Logic

		private void themesItem_Click(object sender, System.EventArgs e)
		{
			this.themesItem.Checked = !this.themesItem.Checked;
			this.barManager1.ThemesEnabled = this.themesItem.Checked;
		}

		#region CUSTOM_MENU_COLORS
		private void customColors_Click(object sender, System.EventArgs e)
		{
			this.customColorsItem.Checked = !this.customColorsItem.Checked;
			// Toggle colors.
			if(this.customColorsItem.Checked)
			{
				// Set custom colors for menu items.
				MenuColors.MenuBGColor = Color.FromArgb(251, 249, 243);
				MenuColors.DropDownBorderColor = Color.FromArgb(158, 133, 56);
				MenuColors.CheckedSelColor = Color.FromArgb(247, 243, 229);
				MenuColors.MenuLeftStripColor = Color.FromArgb(234, 222, 187);
				MenuColors.PressedSelColor = Color.FromArgb(220, 204, 158);
				MenuColors.SelBorderColor = Color.FromArgb(194, 163, 69);
				MenuColors.SelColor = Color.FromArgb(253, 252, 248);
				MenuColors.CommandBarBackColor = Color.FromArgb(234, 222, 187);
				this.BackColor = Color.FromArgb(230, 216, 174);
				MenuColors.MainMenuBackColor = this.BackColor;
				MenuColors.StatusBarBackColor = this.BackColor;
				MenuColors.FloatingCommandBarCaptionColor = Color.FromArgb(198, 166, 70);
				MenuColors.ExpandedMenuStripBackColor = Color.FromArgb(227, 211, 164);
				// Default is 175
				MenuColors.InactiveItemAlphaBlendFactor = 200;
				MenuColors.MenuTextColor = Color.FromArgb(154, 64, 23);
				MenuColors.MenuActiveTextColor = Color.FromArgb(154, 64, 23);
				MenuColors.DisabledMenuTextColorBase = Color.FromArgb(214, 187, 111);
				MenuColors.DisabledToolbarItemTextColorBase = Color.FromArgb(214, 187, 111);
			}
			else
			{
				// Reset custom colors. The menus will then use system colors.
				MenuColors.MenuBGColor = Color.Empty;
				MenuColors.DropDownBorderColor = Color.Empty;
				MenuColors.CheckedSelColor = Color.Empty;
				MenuColors.MenuLeftStripColor = Color.Empty;
				MenuColors.PressedSelColor = Color.Empty;
				MenuColors.SelBorderColor = Color.Empty;
				MenuColors.SelColor = Color.Empty;
				MenuColors.CommandBarBackColor = Color.Empty;
				this.ResetBackColor();
				MenuColors.MainMenuBackColor = Color.Empty;
				MenuColors.StatusBarBackColor = Color.Empty;
				MenuColors.FloatingCommandBarCaptionColor = Color.Empty;
				MenuColors.ExpandedMenuStripBackColor = Color.Empty;
				MenuColors.InactiveItemAlphaBlendFactor = -1;
				MenuColors.MenuTextColor = Color.Empty;
				MenuColors.MenuActiveTextColor = Color.Empty;
				MenuColors.DisabledMenuTextColorBase = Color.Empty;
				MenuColors.DisabledToolbarItemTextColorBase = Color.Empty;
			}
		}
		#endregion CUSTOM_MENU_COLORS
		internal void HideToolBar()
		{
			this.barManager1.GetCommandBarManager().SetBarVisibility(this.bar2, false);
		}

		private void barItem1_Click(object sender, System.EventArgs e)
		{
			switch (counter)
			{
				case 1:
					DerivedForm f1 = new DerivedForm();
					f1.Text = "DerivedChild 1";
					f1.MdiParent = this;
					f1.Show();

					break;
				case 2:
					DerivedForm2 f2 = new DerivedForm2();
					f2.Text = "DerivedChild 2";
					f2.MdiParent = this;
					f2.Show();

					break;
				case 3:
					DerivedForm3 f3 = new DerivedForm3();
					f3.Text = "DerivedChild 3";
					f3.MdiParent = this;
					f3.Show();

					break;
			}
			counter++;
			if (counter == 4)
				counter = 1;
		
		}
	}
}
